%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                      TODO items                              %%
%% Use the \todo command to make notes of things to fix. 
% Apply italics or bold or caps for emphasis as needed, e.g.,
   \newboolean{todos}
   \setboolean{todos}{true}  % set to true to include TODO statements
   %% \setboolean{todos}{false}  % set to false to exclude TODO statements

   %%% INTENDED USE OF THE arxiv AND extralong BOOLEAN VARIABLES
   %%% -- The brief journal version should have `arxiv` and `extralong` variables set to false.
   %%% -- The arxiv version should have `arxiv` set to true and `extralong` set to false.
   %%% -- The extralong version may contain notes intended for our own personal reference.
   %%%    For the extralong version, set both `arxiv` and `extralong` to true.   
   \newboolean{arxiv}
   \setboolean{arxiv}{true}  % set to true to include almost everything
   \setboolean{arxiv}{false}  % set to false for the brief version


   \newboolean{extralong}
   \setboolean{extralong}{true}  % set to true to include everything
   \setboolean{extralong}{false}  % set to false for the long (but not too long) version

   \newboolean{footnotes}
   \setboolean{footnotes}{true}  % set to true to include footnotes
   \setboolean{footnotes}{false}  % set to false for no footnotes

   %%%% wjd: adding pagebreaks for ``draft mode'' to reduce printing costs
   %%%%      To turn off these unnecessary page breaks, set `draft` to false:
   \newboolean{draft}
   \setboolean{draft}{true}  % set to true to include extra pagebreaks
   \setboolean{draft}{false}

   %%
   %% INCLUDE TODO ITEMS by commenting out `\setboolean{todos}{false}`
   %% OMIT TODO ITEMS by uncommenting `\setboolean{todos}{false}`:
   %%   \setboolean{todos}{false}
   %%
   \newcommand{\todo}[1]{\ifthenelse{\boolean{todos}}{%
       \noindent {\bf To do:} #1}{}}
   %%




\usepackage{accents}
\newcommand{\ubar}[1]{\ensuremath{\underaccent{\bar}{#1}}}
%% \newcommand{\ubar}[1]{\ensuremath{\underline{#1}}}
\newcommand{\overbar}[1]{\ensuremath{\bar{#1}}}

\newcommand{\etaR}{\ensuremath{\tilde{\eta}}}
\newcommand{\hto}{\ensuremath{\rightharpoonup}}
\newcommand{\bool}{\ensuremath{\mathtt{Bool}}}
\newcommand{\true}{\ensuremath{\mathtt{true}}}
\newcommand{\false}{\ensuremath{\mathtt{false}}}
\newcommand{\ar}{\ensuremath{\operatorname{ar}}}
\newcommand{\CSP}{\ensuremath{\operatorname{CSP}}}
\newcommand{\dom}{\ensuremath{\operatorname{dom}}}
\newcommand{\cod}{\ensuremath{\operatorname{cod}}}
\newcommand{\im}{\ensuremath{\operatorname{im}}}
\newcommand{\slt}{\ensuremath{\mathbf S_2}\xspace}
\newcommand{\wnu}{\acs{wnu}\xspace}
\newcommand{\tct}{\acs{tct}\xspace}
\newcommand{\ctb}{\acs{ctb}\xspace}
\newcommand{\lics}{\acs{lics}\xspace}
\newcommand{\ec}{\acs{ec}\xspace}
\newcommand{\csp}{\acs{CSP}\xspace}
\newcommand{\mas}{mass\xspace}
\newcommand{\masses}{masses\xspace}
\newcommand{\sat}{\acs{sat}\xspace}
\newcommand{\nae}{\acs{nae}\xspace}
\newcommand{\csps}{\acsp{CSP}\xspace}
\newcommand{\sd}{\acs{sd}\xspace}
\newcommand{\cib}{\acs{cib}\xspace}
\newcommand{\cibs}{\acsp{cib}\xspace}
\newcommand{\PeqNP}{\acs{PeqNP}\xspace}
\newcommand{\PneqNP}{\acs{PneqNP}\xspace}
\newcommand{\NPcomplete}{\acs{NP}-complete\xspace}
\newcommand{\NP}{\acs{NP}\xspace}
\renewcommand{\P}{\acs{P}\xspace}
\newcommand{\mfA}{\ensuremath{\mathfrak{A}}}
\newcommand{\mfX}{\ensuremath{\mathfrak{X}}}
\newcommand{\lb}{\ensuremath{\llbracket}}
\newcommand{\rb}{\ensuremath{\rrbracket}}
\newcommand{\id}{\ensuremath{\operatorname{id}}}
\newcommand{\fin}{\ensuremath{\operatorname{fin}}}
\newcommand{\Eq}{\ensuremath{\operatorname{Eq}}}
\newcommand{\Rel}{\ensuremath{\operatorname{Rel}}}
\newcommand{\Inj}{\ensuremath{\operatorname{Inj}}}
\newcommand{\Proj}{\ensuremath{\operatorname{Proj}}}
\newcommand{\arity}{\ensuremath{\operatorname{arity}}}
\newcommand{\Op}{\ensuremath{\operatorname{Op}}}
\newcommand{\alg}[1]{\ensuremath{\mathbf{#1}}}
\newcommand{\var}[1]{\ensuremath{\mathcal{#1}}}
\newcommand{\Set}{\ensuremath{\mathbf{Set}}}
\newcommand{\op}{\ensuremath{\operatorname{op}}}
\newcommand{\Sub}{\ensuremath{\operatorname{Sub}}}
\newcommand{\Con}{\ensuremath{\operatorname{Con}}}
\newcommand{\Cg}{\ensuremath{\operatorname{Cg}}}
\newcommand{\Sg}{\ensuremath{\operatorname{Sg}}}
\newcommand{\Clo}{\ensuremath{\operatorname{\mathsf{Clo}}}}
\newcommand{\typ}{\ensuremath{\operatorname{typ}}}
\newcommand{\Pol}{\ensuremath{\operatorname{Pol}}}
\newcommand{\Poly}{\ensuremath{\operatorname{Poly}}}
\newcommand{\V}{\ensuremath{\operatorname{V}}}
\newcommand{\sdp}{\ensuremath{\leq_{\mathrm{sd}}}}
\newcommand{\defn}[1]{\textit{#1}}
\newcommand{\N}{\ensuremath{\mathbb{N}}}
\newcommand{\SDwedge}{\ensuremath{\mbox{SD}_\wedge}}
\newcommand{\<}{\ensuremath{\langle}}
\renewcommand{\>}{\ensuremath{\rangle}}
\newcommand{\bR}{\ensuremath{\mathbf{R}}}
\newcommand{\bn}{\ensuremath{\mathbf{n}}}
\newcommand{\sansA}{\ensuremath{\mathsf{A}}}
\newcommand{\sansComp}{\ensuremath{\mathsf{comp}}}
\newcommand{\sansC}{\ensuremath{\mathsf{C}}}
\newcommand{\sansH}{\ensuremath{\mathsf{H}}}
\newcommand{\sansO}{\ensuremath{\mathsf{O}}} % ALL FINITARY OPERATIONS
\newcommand{\sansP}{\ensuremath{\mathsf{P}}}
\newcommand{\sansPoly}{\ensuremath{\mathsf{Pol}}}
\newcommand{\sansPol}{\ensuremath{\mathsf{Pol}}}
\newcommand{\sansRel}{\ensuremath{\mathsf{Inv}}}
\newcommand{\sansInv}{\ensuremath{\mathsf{Inv}}}
\newcommand{\sansClo}{\ensuremath{\operatorname{\mathsf{Clo}}}}
\newcommand{\sansR}{\ensuremath{\mathsf{R}}} % ALL FINITARY RELATIONS
\newcommand{\sansS}{\ensuremath{\mathsf{S}}}
\newcommand{\sansT}{\ensuremath{\mathsf{T}}}
\newcommand{\onlyif}{\ensuremath{\Longrightarrow}}
%% \newcommand\ubA{\ensuremath{\underline{\mathbf{A}}}}
\newcommand\ubA{\ensuremath{\ubar{\mathbf{A}}}}
%% \newcommand\uA{\ensuremath{\underline{A}}}
\newcommand\uA{\ensuremath{\ubar{A}}}
\newcommand{\bbA}{\ensuremath{\mathbb{A}}}
\newcommand{\bbB}{\ensuremath{\mathbb{B}}}
\newcommand{\bbC}{\ensuremath{\mathbb{C}}}
\newcommand{\bbD}{\ensuremath{\mathbb{D}}}
\newcommand{\bbS}{\ensuremath{\mathbb{S}}}
\newcommand{\bbV}{\ensuremath{\mathbb{V}}}
\newcommand{\bs}{\ensuremath{\mathbf{s}}}
\newcommand{\sA}{\ensuremath{\mathscr{A}}}
\newcommand{\sB}{\ensuremath{\mathscr{B}}}
\newcommand{\sC}{\ensuremath{\mathscr{C}}}
\newcommand{\sF}{\ensuremath{\mathscr{F}}}
\newcommand{\sI}{\ensuremath{\mathscr{I}}}
\newcommand{\sM}{\ensuremath{\mathscr{M}}}
\newcommand{\sP}{\ensuremath{\mathscr{P}}}
\newcommand{\sR}{\ensuremath{\mathscr{R}}}
\newcommand{\sS}{\ensuremath{\mathscr{S}}}
\newcommand{\sT}{\ensuremath{\mathscr{T}}}
\newcommand{\sV}{\ensuremath{\mathscr{V}}}
\newcommand{\sW}{\ensuremath{\mathscr{W}}}
\newcommand{\cS}{\ensuremath{\mathcal{S}}}
\newcommand{\bA}{\ensuremath{\mathbf{A}}}
\newcommand{\ba}{\ensuremath{\mathbf{a}}}
\newcommand{\bB}{\ensuremath{\mathbf{B}}}
\newcommand{\bb}{\ensuremath{\mathbf{b}}}
\newcommand{\bC}{\ensuremath{\mathbf{C}}}
\newcommand{\bc}{\ensuremath{\mathbf{c}}}
\newcommand{\bD}{\ensuremath{\mathbf{D}}}
\newcommand{\vf}{\ensuremath{\mathbf{f}}}
\newcommand{\bF}{\ensuremath{\mathbf{F}}}
\newcommand{\bP}{\ensuremath{\mathbf{P}}}
\newcommand{\bQ}{\ensuremath{\mathbf{Q}}}
\newcommand{\br}{\ensuremath{\mathbf{r}}}
\newcommand{\bS}{\ensuremath{\mathbf{S}}}
\newcommand{\bT}{\ensuremath{\mathbf{T}}}
\newcommand{\bt}{\ensuremath{\mathbf{t}}}
\newcommand{\bu}{\ensuremath{\mathbf{u}}}
\newcommand{\bv}{\ensuremath{\mathbf{v}}}
\newcommand{\bw}{\ensuremath{\mathbf{w}}}
\newcommand{\bx}{\ensuremath{\mathbf{x}}}
\newcommand{\vy}{\ensuremath{\mathbf{y}}}
\newcommand{\bz}{\ensuremath{\mathbf{z}}}
\newcommand{\bzero}{\ensuremath{\mathbf{0}}}
\newcommand{\Sol}{\ensuremath{\operatorname{Sol}}}

%% \newcommand{\JJ}{\ensuremath{\underline{J}}}
%% \newcommand{\nn}{\ensuremath{\underline{n}}}
%% \newcommand{\mm}{\ensuremath{\underline{m}}}
%% \newcommand{\pp}{\ensuremath{\underline{p}}}
%% \newcommand{\kk}{\ensuremath{\underline{k}}}
%% \newcommand{\ul}{\ensuremath{\underline{\ell}}}
%% \newcommand{\uzero}{\ensuremath{\underline{0}}}
%% \newcommand{\uone}{\ensuremath{\underline{1}}}
%% \newcommand{\utwo}{\ensuremath{\underline{2}}}
%% \newcommand{\uthree}{\ensuremath{\underline{3}}}
%% \newcommand{\kplus}{\ensuremath{\underline{k+1}}}

\newcommand{\JJ}{\ensuremath{\ubar{J}}}
\newcommand{\nn}{\ensuremath{\ubar{n}}}
\newcommand{\mm}{\ensuremath{\ubar{m}}}
\newcommand{\pp}{\ensuremath{\ubar{p}}}
\newcommand{\kk}{\ensuremath{\ubar{k}}}
\newcommand{\ul}{\ensuremath{\ubar{\ell}}}
\newcommand{\uzero}{\ensuremath{\ubar{0}}}
\newcommand{\uone}{\ensuremath{\ubar{1}}}
\newcommand{\utwo}{\ensuremath{\ubar{2}}}
\newcommand{\uthree}{\ensuremath{\ubar{3}}}
\newcommand{\kplus}{\ensuremath{\underline{k+1}}}


\newcommand{\power}[1]{\ensuremath{\mathscr{P}(#1)}}
\newcommand{\balpha}{\ensuremath{\boldsymbol{\alpha}}}
\newcommand{\bbeta}{\ensuremath{\boldsymbol{\beta}}}
\newcommand{\bgamma}{\ensuremath{\boldsymbol{\gamma}}}
\newcommand{\bdelta}{\ensuremath{\boldsymbol{\delta}}}
\newcommand{\bepsilon}{\ensuremath{\boldsymbol{\epsilon}}}
\newcommand{\AAn}{\ensuremath{A^{(A^n)}}}
\newcommand{\AAm}{\ensuremath{A^{(A^m)}}}
\newcommand{\AAk}{\ensuremath{A^{(A^k)}}}
\newcommand{\meet}{\ensuremath{\wedge}}
\newcommand{\Meet}{\ensuremath{\bigwedge}}
\renewcommand{\Join}{\ensuremath{\bigvee}}
\newcommand{\join}{\ensuremath{\vee}}
\newcommand{\onto}{\ensuremath{\twoheadrightarrow}}
\newcommand{\into}{\ensuremath{\rightarrowtail}}
\newcommand{\fst}{\ensuremath{\operatorname{fst}}}
\newcommand{\snd}{\ensuremath{\operatorname{snd}}}
\newcommand{\absorbing}{\ensuremath{\mathrel{\triangleleft}}}
\newcommand{\minabsorbing}{\ensuremath{\mathrel{\triangleleft\triangleleft}}}
\newcommand{\btheta}{\ensuremath{\bm{\theta}}}
\newcommand{\malcev}{Mal'tsev\xspace}
\renewcommand{\leq}{\ensuremath{\leqslant}}
\renewcommand{\geq}{\ensuremath{\geqslant}}
%% NOTATION FOR CENTRALIZER
\newcommand{\CC}[3]{\ensuremath{\sansC(#1, #2; #3)}} % \CC{a}{b}{c}  for  C(a, b; c)
\newcommand{\C}[2]{\ensuremath{\sansC(#1, #2)}}      % \C{a}{b}      for  C(a, b)
%% \newcommand{\myprod}{\ensuremath{\Pi}} % previously used \Pi for a more compact product symbol
\newcommand{\myprod}{\ensuremath{\prod}}
\newcommand\map{\ensuremath{map}}
\newcommand\restr[2]{{% we make the whole thing an ordinary symbol
  \left.\kern-\nulldelimiterspace % automatically resize the bar with \right
  #1 % the function
  \vphantom{\big|} % pretend it's a little taller at normal size
  \right|_{#2} % this is the delimiter
  }}
%% use like this: \restr{f}{A} (restriction of the function f to the set A)

%%%CLIFF'S STUFF
%% For debugging we want to turn a few facilitites on
%For marginal notes. 
\usepackage{pifont}
\newcommand\mpar[1]{\mbox{}\marginpar{\raggedright\hspace{0pt}\small #1}}
%\newcommand\mpar[1]{\relax} %uncomment to turn off marginal notes
\newcommand{\towjd}[1]{\par \noindent \mpar{\ding{'120}}{{\bf chb:} \emph{#1}}\par}
\newcommand{\tochb}[1]{\par \noindent \mpar{\ding{'121}}{{\bf wjd:} \emph{#1}}\par}
\let\:\colon
\newcommand{\card}[1]{|#1|}
\DeclareMathOperator{\size}{size}
\newcommand{\sansV}{\ensuremath{\mathsf{V}}}
\newcommand{\Sl}{\ensuremath{Sl}} %I don't know what font to use
\newcommand{\Sq}[1]{\ensuremath{\mathbf{Sq}_{#1}}}
\newcommand{\sdm}{\sd-\meet\xspace}
\newcommand{\casespec}[1]{\medskip\noindent\textbf{#1}.\enspace}
%:Cliff's macs
%%% END OF CLIFF'S STUFF
